#include <stdio.h>
#include <ctype.h>

typedef struct MenuePunkt_s MenuePunkt_t;
struct MenuePunkt_s
{  char  zeichen; // Auswahl: Kleinbuchstabe od. Zeichen
   char *text;    // Informeller Text
};
// Auflistung aller Menuepunkte
static MenuePunkt_t menuePunkte[] =
{  { '1', "Eingabe" },
   { '2', "Ausgabe" },
   { '3', "Suchen"  },
   { '4', "Lschen" },
   { '0', "Beenden" },
   { 'm', "Menue"   },
};
#define MENUEPUNKTE_LEN sizeof(menuePunkte) / sizeof(MenuePunkt_t)

/* LeereEingabepuffer: Leert den Standardeingabepuffer
 *                     bis zum nchsten '\n'
 * Parameter:    Keiner
 * Rckgabewert: Keiner
 */
void LeereEingabepuffer()
{  while (getchar() != '\n');
}  // end LeereEingabepuffer

/* Menue: Gibt ein Menue aus
 *        Verwendet Strukturen in menuePunkte
 * Parameter:    Keiner
 * Rckgabewert: Keiner
 */
void Menue()
{  long i;

   printf("\n");
   printf("Men\n");
   printf("=====\n");

   for (i = 0; i < MENUEPUNKTE_LEN; i = i + 1)
      printf(" %c ... %s\n", menuePunkte[i].zeichen, menuePunkte[i].text);

   printf ("\n");
}  // end Menue

/* MenueAuswahl: Benutzerabfrage zum Menue
 * Parameter:    Keiner
 * Rckgabewert: Korrekte Benutzereingabe
 *          Typ: char
 */
char MenueAuswahl()
{  long i;
   char zeichen;

   while (1)
   {  printf("Wahl (m fr Menue): ");
      zeichen = getchar();
      zeichen = tolower(zeichen);
      LeereEingabepuffer();

      if (zeichen == 'm')
      {  Menue();
         continue;
      }
      for (i = 0; i < MENUEPUNKTE_LEN; i = i + 1)
         if (zeichen == menuePunkte[i].zeichen)
            return zeichen;
      printf("Falsche Eingabe!\n");
   }
}  // end MenueAuswahl

main()
{  char zeichen;

   printf("Kleine Adressverwaltung\n");
   printf("=======================\n");
   Menue();

   do
   {  zeichen = MenueAuswahl();
                
      switch (zeichen)
      {case '1':
         printf("Eingabe\n");
         break;
       case '2':
         printf("Ausgabe\n");
         break;
       case '3':
         printf("Suchen\n");
         break;
       case '4':
         printf("Lschen\n");
         break;
      }
   } while (zeichen != '0');
}  // end main
