#include <stdio.h>
#include <string.h>
#include <ctype.h>

#define NAME_LEN    30
#define ORT_LEN     20
#define STRASSE_LEN 50

typedef struct Adresse_s
{  char name[NAME_LEN];       // Name der Person
   long plz;                  // Postleitzahl
   char ort[ORT_LEN];         // Wohnort
   char strasse[STRASSE_LEN]; // Strasse
   long nummer;               // Hausnummer
} Adresse_t;

// Fr das Men werden die Funktionen aus dem vorherigen
// Beispiel gebraucht!

/* getline: Liest eine Textzeile ein
 * Parameter:
 *     str: Zeichenfeld
 *     num: Lnge von Zeichenfeld
 * Rckgabewert: Keiner
 */
void getline (char *str, long num)
{  char c, *strende = str + num - 1;

   if (num > 0 && str)
   {  while ((c = getchar ()) != '\n')
         if (str < strende)
         {  *str = c;
            str = str + 1;
         }
         else
	    break;
      *str = 0;
   }
}  // end getline

/* Eingabe: Einlesen eines Datensatzes
 * Parameter:
 *     adressen: Die gesamte Datenbank
 *     index   : Index des neuen Elementes
 *               gleichzeitig Lnge des Feldes
 * Rckgabewert: Keiner
 */
void Eingabe(Adresse_t adressen[], long *index)
{  printf("\n");
   printf("Name:       ");
   getline(adressen[*index].name, sizeof (adressen[*index].name));
   printf("PLZ:        ");
   scanf("%ld", &adressen[*index].plz);
   getchar();
   printf("Ort:        ");
   getline(adressen[*index].ort, sizeof(adressen[*index].ort));
   printf("Strae:     ");
   getline(adressen[*index].strasse,
           sizeof(adressen[*index].strasse));
   printf("Hausnummer: ");
   scanf("%ld", &adressen[*index].nummer);
   getchar();
   printf("\n");
   *index = *index + 1;
}  // end Eingabe

/* AusgabeDatensatz: Ausgabe eines Datensatzes
 * Parameter:
 *     adressen: Die gesamte Datenbank
 *     index   : Index des Elementes
 * Rckgabewert: Keiner
 */
void AusgabeDatensatz(Adresse_t adressen[], long index)
{  printf("\n");
   printf("Name:       %s\n",  adressen[index].name);
   printf("PLZ:        %ld\n", adressen[index].plz);
   printf("Ort:        %s\n",  adressen[index].ort);
   printf("Strae:     %s\n",  adressen[index].strasse);
   printf("Hausnummer: %ld\n", adressen[index].nummer);
}  // end AusgabeDatensatz

/* Ausgabe: Ausgabe aller Datenstze
 * Parameter:
 *     adressen: Die gesamte Datenbank
 *     anzahl  : Lnge des Feldes
 * Rckgabewert: Keiner
 */
void Ausgabe(Adresse_t adressen[], long anzahl)
{  long i;

   for (i = 0; i < anzahl; i = i + 1)
      AusgabeDatensatz(adressen, i);

   printf("\n");
}  // end Ausgabe

/* SucheName: Suchen nach einem Datensatz anhand
 *            des Namens
 * Parameter:
 *     adressen: Die gesamte Datenbank
 *     anzahl  : Lnge des Feldes
 * Rckgabewert: Position im Feld. -1 bei Fehler
 *          Typ: long
 */
long SucheName(Adresse_t adressen[], long anzahl)
{  char name[NAME_LEN];
   long i;

   printf("Name: ");
   getline(name, NAME_LEN);

   for (i = 0; i < anzahl; i = i + 1)
      if (!(strncmp(name, adressen[i].name, strlen(name))))
         return i;

   return -1;
}  // end SucheName

/* LoescheDatensatz: Lschen eines Datensatzes anhand des Namens
 * Parameter:
 *     adressen: Die gesamte Datenbank
 *     anzahl  : Lnge des Feldes
 * Rckgabewert: Keiner
 */
void LoescheDatensatz(Adresse_t adressen[], long *anzahl)
{  long index;

   index = SucheName(adressen, *anzahl);

   if (index == -1)
   {  printf("\n");
      printf("Datensatz nicht gefunden\n");
      printf("\n");
      return;
   }

   printf("\n");
   AusgabeDatensatz(adressen, index);
   printf("\n");

   printf("Datensatz lschen?: ");
   {  char zeichen;

      zeichen = getchar();
      getchar();
      if (tolower(zeichen) != 'j')
         return;
   }

   for (index = index + 1; index < *anzahl; index = index + 1)
      adressen[index - 1] = adressen[index];

   *anzahl = *anzahl - 1;
}  // end LoescheDatensatz

#define ADRESSBUCH_LEN 20
main()
{  char zeichen;
   Adresse_t Adressbuch[ADRESSBUCH_LEN];
   long anzahl = 0;

   printf("Kleine Adressverwaltung\n");
   printf("=======================\n");
   Menue();

   do
   {  zeichen = MenueAuswahl();
                
      switch (zeichen)
      {case '1':
         if (anzahl < ADRESSBUCH_LEN)
            Eingabe(Adressbuch, &anzahl);
         else
            printf("Datenbank voll!\n");
         break;
       case '2':
         Ausgabe(Adressbuch, anzahl);
         break;
       case '3':
         {  long index;

            printf("\n");
            index = SucheName(Adressbuch, anzahl);
            if (index == -1)
            {  printf("\n");
               printf("Datensatz nicht gefunden\n");
               printf("\n");
            }
            else
            {  AusgabeDatensatz(Adressbuch, index);
               printf("\n");
            }
         }
         break;
       case '4':
         printf("\n");
         LoescheDatensatz(Adressbuch, &anzahl);
         printf("\n");
      }
   } while (zeichen != '0');
}  // end main
